#ifndef __httpd_h
#define __httpd_h

#include <channel.h>
#include <utility/list.h>
#include <thread.h>
#include <ip.h>
#include <tcpm.h>


__BEGIN_SYS

class WebServer {
	public:
	// types
	class Page {
		public:
		enum {
			STATIC,
			DYNAMIC,
		};
		private:
		const char *_data;
		const char *_mime;
		short _type;
		void * _handler;
		public:
		Page(const char* blob,const char* mime) : _data(blob), _mime(mime), _type(STATIC) {}
		Page(void* handler,const char* mime) : _data(0), _mime(mime), _handler(handler), _type(DYNAMIC) {}
		const char* get() {
			//if (_type == STATIC)
			return _data;
			//else
			//return (void (* _handler)())();
		}
		
	};
	private:
	class PageUrl { // association
		public:
		PageUrl(const char* url,Page* page) : _url(url), _page(page), _link(this) {}
		Page* _page;
		const char* _url;
		Simple_List<PageUrl>::Element _link;
	}; 

	public:
	// methods
	WebServer(int port = 80) : _port(port), _worker(new Thread(&WebServer::workerEntry,this)) {}

	void addPage(const char* url,Page *p) {
		_served.insert(&(new PageUrl(url,p))->_link);
	}
	bool delPage(const Page *p);
	bool delPage(const char* url);

	private:
	// attrb
	Simple_List<PageUrl> _served;
	int _port;
	Thread* _worker;

	// methos
	static int workerEntry(WebServer* self)
	{
		TCPServer web(80);
		char buff[4096]; // grabs 4k from the stack
		OStream cout;
		while (true) {
			cout << "WebServer esperando conexao\n";
			TCP::Connection * con = web.accept();
			int msg_size = con->read(buff, 4095);
			buff[msg_size] = 0;
			cout << "Received " << msg_size << " bytes"
				<< "\nMessage: [" << buff << "]\n";
			const char* msg = "HTTP 200 OK\n\r\n\rMensagem recebida!\n";
			con->write(msg, strlen(msg));
		}
	}

}; 

__END_SYS

#endif
