// EPOS-- Mutex Abstraction Declarations

#ifndef __mutex_h
#define __mutex_h

#include <utility/handler.h>
#include <common/synchronizer.h>

__BEGIN_SYS

class Mutex: public Synchronizer_Common
{
public:
    Mutex() : _locked(false) {
	db<Synchronizer>(TRC) << "Mutex() => " << this << "\n"; 
    }
    ~Mutex() {
	db<Synchronizer>(TRC) << "~Mutex(this=" << this << ")\n";
    }

    void lock() { 
	db<Synchronizer>(TRC) << "Mutex::lock(this=" << this << ")\n";
	while(tsl(_locked))
	    sleep();
    }
    void unlock() { 
	db<Synchronizer>(TRC) << "Mutex::unlock(this=" << this << ")\n";
	_locked = false;
	wakeup(); 
    }

private:
    volatile bool _locked;
};

class Handler_Mutex: public Handler
{
public:
    Handler_Mutex(Mutex * h) : _handler(h) {}
    ~Handler_Mutex() {}

    void operator()() { _handler->unlock(); }
	
private:
    Mutex * _handler;
};

__END_SYS

#endif
