#ifndef __tcpm_h
#define __tcpm_h

#include <list.h>
#include <semaphore.h>
#include <utility/debug.h>
#include <utility/string.h>
#include <malloc.h>

__BEGIN_SYS
class TCPClient;
class TCPServer;

class TCP {
	public:
	static Simple_List<TCPServer> _listeners;	

	class Connection {
		public:
		Connection() : _mutex(0) {};

		Connection * other_side;
		Semaphore mutex;
		char * _data;
		int _size;

		int read(char* r,int size) {
			mutex.p();
			memcpy(r,_data,_size);
			return _size;
		}
		void write(char* d,int size) {
			memcpy(other_side._data,d,size);
			other_side._size = size;
			other_side.mutex.v();			
		}
	};

	friend class TCPServer;
	friend class TCPClient;
};

class TCPServer {
	friend class TCPClient;
	public:
	TCPServer(int port) : _port(port), _link(this), _sem(0) {
		TCP::_listeners.insert(&_link);
	}
	~TCPServer() {
		TCP::_listeners.remove(this);
	}
	
	TCP::Connection * accept() {
		_sem.p();
		_client.mycon.other_side = mycon;
		_client._sem.v();
		return &mycon;
	}

	void close(TCP::Connection * c) {
		delete c;
	}

	Connection mycon; 
	TCPClient * _client;
	Semaphore _sem;
	int _port;
	Simple_List<TCPServer>::Element _link;

	bool operator== (int port) { return _port == port); }
};

class TCPClient {
	friend class TCPServer;
	public:

	TCPClient(char* ip,int port) : _port(port), _sem(0) {
		
	};

	TCP::Connection * connect() {
		serv = TCP::_listeners.search(port);
		if (serv) {
			db<TCP>(INF) << "listener found\n";
		}
		serv._client = this;
		serv.mycon.other_side = mycon;
		serv._sem.v();
		_sem.p();
		return &mycon;
	}

	void close(TCP::Connection *c) { delete c; }

	Connection mycon;
	int _port;
	Semaphore _sem;
	TCPServer * _serv;
};

__END_SYS

#endif
