#ifndef __random_h
#define __random_h

#include <system/config.h>
__BEGIN_SYS

/*
	Esta classe fornece um método ágil, porém não validado
	de gerar números pseudo-aleatórios.
	
	Baseado em: 
	http://en.wikipedia.org/wiki/Linear_congruential_generator
	Com A = 2 e C variável em uma simplificação de:
	X1 = aX0 + c
	como:
	X1 = (X0 << 1) xor C 
*/
class Pseudo_Random {
	protected:
	Pseudo_Random() {};
	~Pseudo_Random() {};
	
	static unsigned long int seed;
	public:
	static unsigned long int random(unsigned long int i) { 
		return (seed = (seed << 1) ^ i);
	}
};

__END_SYS
#endif
